#!/usr/bin/env python3
# -*- coding:utf-8 -*-

# To run verbose :
# ./runtest -v

import os
import platform
import sys

from PyQt5 import QtCore
from PyQt5.QtCore import *
from PyQt5.QtWidgets import *
from PyQt5.QtGui import *
from PyOpencascade import Opencascade
from typing import NamedTuple
    
class Sample:
  	name = 'tester'
  	id = 'okidokie'
ok = Sample()

class Runtest(QWidget):
 
    def __init__(self):
        QWidget.__init__(self)

        self.layout = QVBoxLayout(self)
        self.occ = Opencascade()
        self.layout.addWidget(self.occ)
        
        self.button=QPushButton('Python is working!')
        self.layout.addWidget(self.button)
        self.button.clicked.connect(self.my_push)
        
    def my_push(self):    
        property_id_0 = "property_background_picture"
        property_value_0 = "/home/user/Qt_graphics_universal_widget/libpython/Qt_Occ_Python/Debian_Wallpaper.jpg"
        self.occ.setProperty(property_id_0, property_value_0)
        
        property_id_1 = "property_show_interactive_3d_box"
        property_value_1 = 1
        self.occ.setProperty(property_id_1, property_value_1)
        
        property_id_2 = "property_hide_or_show_triedron"
        property_value_2 = 1
        self.occ.setProperty(property_id_2, property_value_2)
        
        property_id_3 = "property_show_orthographic_or_perspective"
        property_value_3 = 1
        self.occ.setProperty(property_id_3, property_value_3)
        
        property_id_4 = "property_view_wireframe_or_shaded"
        property_value_4 = 1
        self.occ.setProperty(property_id_4, property_value_4)
        
        property_id_5 = "property_dro_testrun"
        property_value_5 = 1
        self.occ.setProperty(property_id_5, property_value_5)
        
        self.occ.test(ok.name)

        self.occ.test1(QVariant(['one', 'two', 'three', 'four']))
        
        self.button.setText("pressed");
        
if __name__ == "__main__":
    app = QApplication([])
    main = Runtest()
    main.show()
    sys.exit(app.exec_())

# Base example to convert c++ lib to python lib : https://github.com/eyllanesc/Qt5toPyQt5/tree/master/src

# QtProperty list :
    ## Background color homogenius
    # int property_background_color 					
    # QString property_background_picture 
    # int property_show_interactive_3d_box 
    # int property_show_orthographic_or_perspective 

    ## Viewports
    # int property_view_front 
    # int property_view_back 
    # int property_view_top 
    # int property_view_bottom 
    # int property_view_left 
    # int property_view_right 

    ## View as wireframe or shaded
    # int property_view_wireframe_or_shaded 

    ## Zoom
    # int property_zoom_all 

    ## Erase all
    # int property_erase_all 

    ## Show or hide triedron (3d axis cross)
    # int property_hide_or_show_triedron 
    
    ## Show a dro example
    # int property_dro_testrun













